<?PHP

/* ====================
Seditio - Website engine
Copyright Neocrome
http:/www.neocrome.net

[BEGIN_SED]
File=plugins/calendar/calendar.page.php
Version=1.1
Updated=2006-Nov-12
Type=Plugin
Author=riptide & friends
Description=Plugin to display the events in a calendar
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=calendar
Part=page
File=calendar.page
Hooks=page.tags
Minlevel=0
Order=10
Tags=page.tpl:{PLUGIN_CALENDAR}
[END_SED_EXTPLUGIN]

==================== */

if ( !defined('SED_CODE') ) { die("Wrong URL."); }

require ('plugins/events/inc/config.php');
require ('plugins/events/inc/functions.php');

$path_lang_def	= "plugins/calendar/lang/calendar.en.lang.php";
$path_lang_alt	= "plugins/calendar/lang/calendar.".$usr['lang'].".lang.php";

if (file_exists($path_lang_alt))
	{ require($path_lang_alt); }
elseif (file_exists($path_lang_def))
	{ require($path_lang_def); }

$y = sed_import('y','G','INT');
$n = sed_import('n','G','INT');

$plugin_title = $L['plu_title'];

if ($y=='')
	{ $y = date("Y", $sys['now_offset'] + $usr['timezone'] * 3600); }
if ($n=='')
	{ $n = date("n", $sys['now_offset'] + $usr['timezone'] * 3600); }

$n_next = $n+1;
$n_prev = $n-1;
$y_next = $y;
$y_prev = $y;

if ($n_prev<1)
	{
	$n_prev = 12;
	$y_prev--;
	}

if ($n_next>12)
	{
	$n_next = 1;
	$y_next++;
	}

$col = 0;
$row = 0;

$firstday=date("w",mktime(0,0,0,$n,1,$y));

if ($cfg['plugin']['calendar']['cal_weekstarts'] == "Sunday")
	{
	$firstday++;
	}
else
	{
	if ($firstday==0)
		{ $firstday = 7; }
	}

$today_d = date("j",$sys['now_offset'] + $usr['timezone'] * 3600);
$today_m = date("n",$sys['now_offset'] + $usr['timezone'] * 3600);
$today_y = date("Y",$sys['now_offset'] + $usr['timezone'] * 3600);
$n_c = date("F",mktime(0,0,0,$n,1,$y));
$n_c = ereg_replace($n_c,$L_month[$n_c],$n_c);
$n_c .= date(" Y",mktime(0,0,0,$n,1,$y));
$n_p = date("F",mktime(0,0,0,$n-1,1,$y));
$n_p = ereg_replace($n_p,$L_month[$n_p],$n_p);
$n_p .= date("",mktime(0,0,0,$n-1,1,$y));
$n_n = date("F",mktime(0,0,0,$n+1,1,$y));
$n_n = ereg_replace($n_n,$L_month[$n_n],$n_n);
$n_n .= date("",mktime(0,0,0,$n+1,1,$y));
$l1 = sed_mktime(0,0,0,$n,1,$y);
$l2 = sed_mktime(0,0,0,$n+1,1,$y);


$sql = sed_sql_query("SELECT i.*, e.* FROM $db_event_instances AS i INNER JOIN $db_events AS e ON i.instance_eventid=e.event_id WHERE event_state='0' AND event_cat!='training' AND (instance_start>='$l1' AND instance_start<'$l2' OR instance_end>='$l1' AND instance_end<'$l2') ORDER BY instance_start");

while ($row = sed_sql_fetcharray($sql)) {
	$event_date = date("j", $row['instance_start'] + $usr['timezone'] * 3600);
	$event_expire = date("j", $row['instance_end'] + $usr['timezone'] * 3600);
	$event_date_month = date("n", $row['instance_start'] + $usr['timezone'] * 3600);
	$event_expire_month = date("n", $row['instance_end'] + $usr['timezone'] * 3600);
	$event_date_year = date("Y", $row["instance_start"] + $usr['timezone'] * 3600);
	$event_expire_year = date("Y", $row["instance_end"] + $usr['timezone'] * 3600);
	$event_title = $row['event_title'];

	if ($cfg['plugin']['calendar']['cal_showeventtext'] == "Yes") {
        if ($row["instance_start"]>=$sys['now_offset'] || $row["instance_end"]>=$sys['now_offset']) {
            $index_cal_bottom .= "<tr><td align=\"left\" colspan=\"7\" style=\"padding:1px 2px;\">".date($cfg['formatyearmonthday'],$row["instance_start"]+$stimezone*3600)." - ".date($cfg['formatyearmonthday'], $row["instance_end"]+$stimezone*3600);
            $index_cal_bottom .= "<br /><a href=\"plug.php?e=events&amp;m=details&amp;id=".$row["event_id"]."&amp;instance=".$row["instance_id"]."\">";

            if ($cfg['plugin']['calendar']['cal_showcategoryonidxcal'] == "Yes") {
				$index_cal_bottom .= sed_cutstring(sed_cc($event_cat[$row["event_cat"]]['title']),30).":&nbsp;";
			}

            $index_cal_bottom .= sed_cutstring(sed_cc($row["event_title"]),30)."</a></td></tr>";
    	}
    }

	if ($event_expire_month-$event_date_month > 0) {
		if ($event_date_month == $n) {
			$event_expire = '31';
		}
		else {
			$event_date = '1';
		}
	}
	
	if ($event_expire_year-$event_date_year > 0) {
		if ($event_date_year == $y) {
			$event_expire = "31";
		}
		else {
			$event_date = "1";
		}
	}
	
	while ($event_date<=$event_expire) {
		$ev[$event_date] = 1;
		$event_date++;
	}
}

$index_cal  = "<table style=\"width:100%;\" id=\"calendar\">";
$index_cal .= "<tr><td colspan=\"1\" style=\"vertical-align:bottom; text-align:center;\"><a href=\"index.php?e=calendar&amp;n=".$n_prev."&amp;y=".$y_prev."\" title=\"".$L_idx['last']."\" style=\"display:block;\">".$sed_img_left."</a></td>";
$index_cal .= "<td colspan=\"5\" style=\"vertical-align:bottom; text-align:center;\"><strong>".$n_c."</strong></td>";
$index_cal .= "<td colspan=\"1\" style=\"vertical-align:bottom; text-align:center;\"><a href=\"index.php?e=calendar&amp;n=".$n_next."&amp;y=".$y_next."\" title=\"".$L_idx['next']."\" style=\"display:block;\">".$sed_img_right."</a></td></tr>";
$index_cal .= "<tr>";

$cal_idxbackgroundcolor = "#".$cfg['plugin']['calendar']['cal_idxbackgroundcolor'];

if ($cfg['plugin']['calendar']['cal_weekstarts'] == "Sunday")
	{
   	$index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Su']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Mo']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Tu']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['We']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Th']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Fr']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Sa']."</td></tr><tr>";
	}
else
	{
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Mo']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Tu']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['We']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Th']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Fr']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Sa']."</td>";
    $index_cal .= "<td style=\"text-align:center;padding:2px;spacing:2px;background-color:".$cal_idxbackgroundcolor.";\">".$L_day['Su']."</td></tr><tr>";
	}

for ($col = 1; $col < $firstday; $col++)
	{ $index_cal .= "<td style=\"background-color:".$cal_idxbackgroundcolor.";\">&nbsp;</td>"; }

for ($i = 1; $i < 32; $i++)
	{
	if (checkdate($n,$i,$y))
		{
		if ($today_d==$i && $today_m==$n && $today_y==$y)
			{
			$mark_color = "#".$cfg['plugin']['calendar']['cal_idxtodaymarkcolor'];
			$mark_border = "";
			}
    		else
			{
			$mark_color = "#".$cfg['plugin']['calendar']['cal_idxdaymarkcolor'];
			$mark_border = "";
			}

		if ( $ev[$i] == 1)
			{
			$mark_color = "#".$cfg['plugin']['calendar']['cal_idxeventmarkcolor'];
			$is_ev = "<td style=\"text-align:center;background-color:".$mark_color.";".$mark_border."\"><strong><a href=\"plug.php?e=events&amp;f=getdate&amp;d=".$i."&amp;m=".$n."&amp;y=".$y."\" style=\"display:block;\">".$i."</a></strong></td>";
			}
		else
			{
			$is_ev = "<td style=\"text-align:center;background-color:".$mark_color.";".$mark_border."\">".$i."</td>";
			}

		$index_cal .= $is_ev;
		$col++;

		if ($col>7)
			{
			$col=1;
			$index_cal .= "</tr><tr>";
			}
		}
	}

$index_cal .= "</tr>";

if ($cfg['plugin']['calendar']['cal_showeventtext'] == "Yes")
	{
	$index_cal .= $index_cal_bottom;
	}

$index_cal .= "<tr><td align=\"left\" colspan=\"4\"><a href=\"plug.php?e=events\">".$L_idx['all']."</a></td>";
$index_cal .= "<td align=\"right\" colspan=\"3\"><a href=\"plug.php?e=calendar\">".$L_idx['cal']."</a></td></tr>";
$index_cal .= "</table>";

$t-> assign(array(
"PLUGIN_CALENDAR" => $index_cal,
));

?>
