<?PHP

/* ====================
Seditio - Website engine
Copyright Neocrome
http:/www.neocrome.net

[BEGIN_SED]
File=plugins/calendar/calendar.php
Version=1.1
Updated=2006-Nov-12
Type=Plugin
Author=riptide & friends
Description=Plugin to display the events in a calendar
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=calendar
Part=plugin
File=calendar
Hooks=standalone
Minlevel=0
Order=10
Tags=
[END_SED_EXTPLUGIN]

==================== */

if ( !defined('SED_CODE') || !defined('SED_PLUG') ) { die("Wrong URL."); }

require ('plugins/events/inc/config.php');
require ('plugins/events/inc/functions.php');


$y = sed_import('y','G','INT');
$m = sed_import('m','G','INT');

$plugin_title = $L['plu_title'];

if ($y=='')
	{ $y = date("Y", $sys['now_offset'] + $usr['timezone'] * 3600); }
if ($m=='')
	{ $m = date("n", $sys['now_offset'] + $usr['timezone'] * 3600); }

$m_next = $m+1;
$m_prev = $m-1;
$y_next = $y;
$y_prev = $y;

if ($m_prev<1)
	{
	$m_prev = 12;
	$y_prev--;
	}

if ($m_next>12)
	{
	$m_next = 1;
	$y_next++;
	}

$col = 0;
$row = 0;

$firstday=date("w",mktime(0,0,0,$m,1,$y));

if ($cfg['plugin']['calendar']['cal_weekstarts'] == "Sunday")
	{
	$firstday++;
	}
else
	{
	if ($firstday==0)
		{ $firstday = 7; }
	}

$today_d = date("j",$sys['now_offset'] + $usr['timezone'] * 3600);
$today_m = date("n",$sys['now_offset'] + $usr['timezone'] * 3600);
$today_y = date("Y",$sys['now_offset'] + $usr['timezone'] * 3600);
$m_c = date("F",mktime(0,0,0,$m,1,$y));
$m_c = ereg_replace($m_c,$L_month[$m_c],$m_c);
$m_c .= date(" Y",mktime(0,0,0,$m,1,$y));
$m_p = date("F",mktime(0,0,0,$m-1,1,$y));
$m_p = ereg_replace($m_p,$L_month[$m_p],$m_p);
$m_p .= date(" Y",mktime(0,0,0,$m-1,1,$y));
$m_n = date("F",mktime(0,0,0,$m+1,1,$y));
$m_n = ereg_replace($m_n,$L_month[$m_n],$m_n);
$m_n .= date(" Y",mktime(0,0,0,$m+1,1,$y));
$l1 = sed_mktime(0,0,0,$m,1,$y);
$l2 = sed_mktime(0,0,0,$m+1,1,$y);

$sql = sed_sql_query("SELECT i.*, e.* FROM $db_event_instances AS i INNER JOIN $db_events AS e ON i.instance_eventid=e.event_id WHERE event_state='0' AND event_cat!='training' AND (instance_start>='$l1' AND instance_start<'$l2' OR instance_end>='$l1' AND instance_end<'$l2') ORDER BY instance_start");

while ($row = sed_sql_fetcharray($sql))
{
	$event_date = date("j", $row["instance_start"] + $usr['timezone'] * 3600);
	$event_expire = date("j", $row["instance_end"] + $usr['timezone'] * 3600);
	$event_date_month = date("n", $row["instance_start"] + $usr['timezone'] * 3600);
	$event_expire_month = date("n", $row["instance_end"] + $usr['timezone'] * 3600);
	$event_date_year = date("Y", $row["instance_start"] + $usr['timezone'] * 3600);
	$event_expire_year = date("Y", $row["instance_end"] + $usr['timezone'] * 3600);

	if ($event_expire_month-$event_date_month > 0) {
		if ($event_date_month == $m) {
			$event_expire = "31";
		}
		else {
			$event_date = "1";
		}
	}
	
	if ($event_expire_year-$event_date_year > 0) {
		if ($event_date_year == $y) {
			$event_expire = "31";
		}
		else {
			$event_date = "1";
		}
	}
	
	while ($event_date <= $event_expire) {
		if ($cfg['plugin']['calendar']['cal_showcategoryonbigcal'] == "Yes") {
			$showcat = sed_cc(sed_cutstring($event_cat[$row["event_cat"]]['title'],30)).": ";
		}
		$ev[$event_date][] = array(
			'id'=>$row['event_id'], 'instance'=>$row['instance_id'], 'number'=>$row['instance_number'], 'state'=>$row['event_state'], 'cat'=>$row['event_cat'], 'date'=>$row['event_date'], 
			'start'=>$row['instance_start'], 'end'=>$row['instance_end'], 'deadline'=>$row['instance_deadline'], 'maxparticipants'=>$row['event_maxparticipants'], 
			'repeat'=>$row['event_repeat'], 'lastoccurrence'=>$row['event_lastoccurrence'], 'title'=>$row['event_title'], 
			'extra1'=>$row['event_extra1'], 'extra2'=>$row['event_extra2'], 'text'=>$row['event_text'], 
			'url'=>$row['event_url'], 'ownerid'=>$row['event_ownerid'], 'alias'=>$row['event_alias'],
			'fulltitle' => $showcat.sed_cutstring(sed_cc($row["event_title"]),32)
		);
		$event_date++;
	}
}

$plugin_body = "<table class=\"flat\">";
$plugin_body .= "<tr><td colspan=\"2\"><a href=\"plug.php?e=calendar&amp;m=".$m_prev."&amp;y=".$y_prev."\">";
$plugin_body .= $sed_img_left." ".$m_p."</a></td>";
$plugin_body .= "<td colspan=\"3\" style=\"text-align:center;\"><strong>".$m_c."</strong></td>";
$plugin_body .= "<td colspan=\"2\"style=\"text-align:right;\"><a href=\"plug.php?e=calendar&amp;m=".$m_next."&amp;y=".$y_next."\">".$m_n." ";
$plugin_body .= $sed_img_right."</a></td></tr>";
$plugin_body .= "<tr><td><a href=\"plug.php?e=calendar&amp;m=".$m."&amp;y=".($y-1)."\">";
$plugin_body .= $sed_img_left." ".($y-1)."</a></td>";
$plugin_body .= "<td colspan=\"5\" style=\"text-align:center;\">";
for ($ii = 1; $ii < 13; $ii++) {
	$plugin_body .= "<a href=\"plug.php?e=calendar&amp;m=".$ii."&amp;y=".$y."\">".$L_month[$ii]."</a> &nbsp;"; 
}
$plugin_body .= "</td>";
$plugin_body .= "<td style=\"text-align:right;\"><a href=\"plug.php?e=calendar&amp;m=".$m."&amp;y=".($y+1)."\">".($y+1);
$plugin_body .= $sed_img_right."</a></td></tr>";
$plugin_body .= "<tr><td colspan=\"7\">&nbsp;</td></tr></table><table class=\"cells\"><tr>";

$cal_backgroundcolor = "#".$cfg['plugin']['calendar']['cal_backgroundcolor'];

if ($cfg['plugin']['calendar']['cal_weekstarts'] == "Sunday")
	{
	$plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['7']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['1']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['2']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['3']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['4']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['5']."</td>";
    $plugin_body .= "<td  style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['6']."</td></tr><tr>";
	}
else
	{
   	$plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['1']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['2']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['3']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['4']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['5']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['6']."</td>";
    $plugin_body .= "<td style=\"text-align:center;width:14%;background-color:".$cal_backgroundcolor.";\">".$L_day['7']."</td></tr><tr>";
	}

for ($col = 1; $col < $firstday; $col++)
	{ $plugin_body .= "<td style=\"background-color:".$cal_backgroundcolor.";\">&nbsp;</td>"; }

for ($i = 1; $i < 32; $i++)
	{
	if (checkdate($m,$i,$y))
		{
		if ($today_d==$i && $today_m==$m && $today_y==$y)
			{
			$mark = " (".$L['today'].")";
			$mark_color = "#".$cfg['plugin']['calendar']['cal_todaymarkcolor'];
			}
    		else
			{
			$mark = "";
			$mark_color = "#".$cfg['plugin']['calendar']['cal_daymarkcolor'];
			}
		$plugin_body .= "<td style=\"height:64px;vertical-align:top;background-color:".$mark_color.";\"><a href='plug.php?e=events&amp;f=getdate&amp;d=$i&amp;m=$m&amp;y=$y'>".$i."</a> ".$mark."<br />";
		if (!empty($ev[$i])) {
			foreach($ev[$i] as $event) {
				$plugin_body .= "<a href=\"plug.php?e=events&amp;m=details&amp;id=".$event['id']."&amp;instance=".$event['instance']."\">".$event['fulltitle']."</a><br />";
			}
		}
		$plugin_body .= "</td>";
		$col++;

		if ($col>7)
			{
			$col=1;
			$plugin_body .= "</tr><tr>";
			}
		}
	}

$plugin_body .= "</tr>";
$plugin_body .= "</table>";

?>